<template>
    <div>
        <span class="tag" @click="toggleSelection">
            <app-icon size="sm" icon="tags"></app-icon>
            <span
                v-if="!note || note.tags.length > 0"
                class="number"
            >{{ note?note.tags.length: '' }}</span>
        </span>
        <transition name="move-up">
            <section class="selection" v-if="open">
                <div class="action">
                    <app-icon @click="toggleSelection" icon="times-circle"></app-icon>
                </div>
                <div class="tags">
                    <span v-if="!note || note.tags.length < 1" class="no-tags">No Tags</span>
                    <span
                        class="tag"
                        @click="removeTag(tag)"
                        v-for="(tag, index) in note.tags"
                        :key="index"
                    >
                        <span class="title">{{ tag.name }}</span>
                        <span class="icon">
                            <app-icon icon="times-circle"></app-icon>
                        </span>
                    </span>
                </div>
                <ol class="list-of-tags">
                    <li @click="addTag(tag)" v-for="(tag, index) in tags" :key="index">{{ tag.name}}</li>
                </ol>
            </section>
        </transition>
    </div>
</template>

<style lang="css" scoped>
.move-up-enter-active,
.move-up-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.move-up-enter,
.move-up-leave-to {
    opacity: 0;
    transform: translateY(200px);
}
</style>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'
import { offlineDB } from '@/offline/db'
import { INote } from '@/store/types/notebooks'
import { IRoot } from '@/store/types/root'
import { ITag } from '@/store/types/tags'
import { from } from 'rxjs'

@Component
export default class TagsOfNote extends Vue {
    // Props
    @Prop() note: INote | undefined

    // State

    @State((state: IRoot) => {
        return state.Tags.tags
    })
    tags: ITag[] | undefined

    // data

    open: boolean = false

    // Methods

    toggleSelection() {
        this.open = !this.open
    }

    doesTagExist(tag: ITag): boolean {
        if (this.note) {
            const tagFound = this.note.tags.filter(_tag => _tag.id === tag.id)

            if (tagFound.length > 0) {
                return true
            } else {
                return false
            }
        }
        return false
    }

    addTag(tag: ITag) {
        if (!this.doesTagExist(tag) && this.note) {
            this.note.tags.push(tag)
            offlineDB.saveNote(this.note)
        }
        this.toggleSelection()
    }

    removeTag(tag: ITag) {
        if (this.doesTagExist(tag) && this.note) {
            const index = this.note.tags.findIndex(_tag => _tag.id === tag.id)

            if (index !== -1) {
                this.note.tags.splice(index, 1)
                offlineDB.saveNote(this.note)
            }
        }
        this.toggleSelection()
    }
}
</script>